package usecase

import "context"

type MailClientUseCase interface {
	SendMail(ctx context.Context, req MailReq) error
}

type MailReq struct {
	To      string
	From    string
	Subject string
	Body    string
}

type MailUseCase interface {
	GetMailTemplateByID(ctx context.Context, tid int64) ([]rune, error)
}
